**@rickosborne/foundation v2024.12.28**

***

# @rickosborne/foundation

Basic data structures and algorithms.

## Classes

- [ArrayBinaryMinHeap](classes/ArrayBinaryMinHeap.md)
- [PriorityArray](classes/PriorityArray.md)
- [PriorityLinkedList](classes/PriorityLinkedList.md)
- [SkipList](classes/SkipList.md)

## Type Aliases

- [BinaryIndexOfConfig](type-aliases/BinaryIndexOfConfig.md)
- [ChainableComparator](type-aliases/ChainableComparator.md)
- [ComparatorBuilder](type-aliases/ComparatorBuilder.md)
- [DoubleLinkedList](type-aliases/DoubleLinkedList.md)
- [GetPropertyDescriptor](type-aliases/GetPropertyDescriptor.md)
- [GetSetPropertyDescriptor](type-aliases/GetSetPropertyDescriptor.md)
- [IfReadOnlyDescriptor](type-aliases/IfReadOnlyDescriptor.md)
- [IfReadWriteDescriptor](type-aliases/IfReadWriteDescriptor.md)
- [IfWriteOnlyDescriptor](type-aliases/IfWriteOnlyDescriptor.md)
- [IntGenerator](type-aliases/IntGenerator.md)
- [IntGeneratorTo](type-aliases/IntGeneratorTo.md)
- [IntRange](type-aliases/IntRange.md)
- [List](type-aliases/List.md)
- [ListWalkDecision](type-aliases/ListWalkDecision.md)
- [PropertiesFromDescriptors](type-aliases/PropertiesFromDescriptors.md)
- [PropertyDescriptorFlags](type-aliases/PropertyDescriptorFlags.md)
- [PropertyFromDescriptor](type-aliases/PropertyFromDescriptor.md)
- [Queue](type-aliases/Queue.md)
- [ReadOnlyDescriptorsKeys](type-aliases/ReadOnlyDescriptorsKeys.md)
- [ReadOnlyPropertyDescriptor](type-aliases/ReadOnlyPropertyDescriptor.md)
- [ReadWriteDescriptorsKeys](type-aliases/ReadWriteDescriptorsKeys.md)
- [RenamedWriteOnlyDescriptorsKeys](type-aliases/RenamedWriteOnlyDescriptorsKeys.md)
- [RenameIfWriteOnlyDescriptor](type-aliases/RenameIfWriteOnlyDescriptor.md)
- [SearchResult](type-aliases/SearchResult.md)
- [SetPropertyDescriptor](type-aliases/SetPropertyDescriptor.md)
- [ShuffleConfig](type-aliases/ShuffleConfig.md)
- [TypedPropertyDescriptor](type-aliases/TypedPropertyDescriptor.md)
- [ValuePropertyDescriptor](type-aliases/ValuePropertyDescriptor.md)

## Variables

- [intRange](variables/intRange.md)

## Functions

- [addProperties](functions/addProperties.md)
- [addProperty](functions/addProperty.md)
- [arrayBinaryMaxHeap](functions/arrayBinaryMaxHeap.md)
- [arrayBinaryMinHeap](functions/arrayBinaryMinHeap.md)
- [binaryIndexOf](functions/binaryIndexOf.md)
- [chainableComparator](functions/chainableComparator.md)
- [comparatorBuilder](functions/comparatorBuilder.md)
- [deepSort](functions/deepSort.md)
- [doubleLinkedList](functions/doubleLinkedList.md)
- [numberAsc](functions/numberAsc.md)
- [priorityArray](functions/priorityArray.md)
- [priorityLinkedList](functions/priorityLinkedList.md)
- [shuffle](functions/shuffle.md)
- [singleLinkedList](functions/singleLinkedList.md)
- [skipList](functions/skipList.md)
- [toShuffled](functions/toShuffled.md)
- [withNullsFirst](functions/withNullsFirst.md)
- [withNullsLast](functions/withNullsLast.md)
