[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / ArrayBinaryMinHeap

# Class: ArrayBinaryMinHeap\<T\>

## Type Parameters

• **T**

## Implements

- [`Queue`](../type-aliases/Queue.md)\<`T`\>

## Constructors

### new ArrayBinaryMinHeap()

> **new ArrayBinaryMinHeap**\<`T`\>(`comparator`): [`ArrayBinaryMinHeap`](ArrayBinaryMinHeap.md)\<`T`\>

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`ArrayBinaryMinHeap`](ArrayBinaryMinHeap.md)\<`T`\>

#### Defined in

[foundation/ts/binary-heap.ts:8](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L8)

## Accessors

### length

#### Get Signature

> **get** **length**(): `number`

##### Returns

`number`

#### Implementation of

`Queue.length`

#### Defined in

[foundation/ts/binary-heap.ts:11](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L11)

***

### unsorted

#### Get Signature

> **get** **unsorted**(): `T`[]

##### Returns

`T`[]

#### Defined in

[foundation/ts/binary-heap.ts:133](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L133)

## Methods

### add()

> **add**(`value`): `void`

#### Parameters

##### value

`T`

#### Returns

`void`

#### Implementation of

`Queue.add`

#### Defined in

[foundation/ts/binary-heap.ts:15](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L15)

***

### addAll()

> **addAll**(`values`): `void`

#### Parameters

##### values

`Iterable`\<`T`, `any`, `any`\>

#### Returns

`void`

#### Defined in

[foundation/ts/binary-heap.ts:21](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L21)

***

### down()

> `protected` **down**(`index`): `void`

#### Parameters

##### index

`number`

#### Returns

`void`

#### Defined in

[foundation/ts/binary-heap.ts:27](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L27)

***

### minChild()

> `protected` **minChild**(`index`): `number`

#### Parameters

##### index

`number`

#### Returns

`number`

#### Defined in

[foundation/ts/binary-heap.ts:42](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L42)

***

### peek()

> **peek**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.peek`

#### Defined in

[foundation/ts/binary-heap.ts:52](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L52)

***

### remove()

> **remove**(`item`): `void`

#### Parameters

##### item

`T`

#### Returns

`void`

#### Implementation of

`Queue.remove`

#### Defined in

[foundation/ts/binary-heap.ts:56](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L56)

***

### sort()

> **sort**(): `void`

#### Returns

`void`

#### Defined in

[foundation/ts/binary-heap.ts:86](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L86)

***

### take()

> **take**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.take`

#### Defined in

[foundation/ts/binary-heap.ts:105](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L105)

***

### toArray()

> **toArray**(): `T`[]

#### Returns

`T`[]

#### Implementation of

`Queue.toArray`

#### Defined in

[foundation/ts/binary-heap.ts:112](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L112)

***

### up()

> `protected` **up**(`index`): `void`

#### Parameters

##### index

`number`

#### Returns

`void`

#### Defined in

[foundation/ts/binary-heap.ts:116](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L116)

***

### values()

> **values**(): `Generator`\<`T`, `void`, `undefined`\>

#### Returns

`Generator`\<`T`, `void`, `undefined`\>

#### Implementation of

`Queue.values`

#### Defined in

[foundation/ts/binary-heap.ts:137](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L137)

***

### valuesAndIndexes()

> `protected` **valuesAndIndexes**(): `Generator`\<[`T`, `number`], `void`, `undefined`\>

#### Returns

`Generator`\<[`T`, `number`], `void`, `undefined`\>

#### Defined in

[foundation/ts/binary-heap.ts:143](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-heap.ts#L143)
