[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / PriorityArray

# Class: PriorityArray\<T\>

## Type Parameters

• **T**

## Implements

- [`Queue`](../type-aliases/Queue.md)\<`T`\>

## Constructors

### new PriorityArray()

> **new PriorityArray**\<`T`\>(`comparator`): [`PriorityArray`](PriorityArray.md)\<`T`\>

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`PriorityArray`](PriorityArray.md)\<`T`\>

#### Defined in

[foundation/ts/priority-array.ts:8](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L8)

## Accessors

### \[toStringTag\]

#### Get Signature

> **get** **\[toStringTag\]**(): `string`

##### Returns

`string`

#### Defined in

[foundation/ts/priority-array.ts:11](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L11)

***

### length

#### Get Signature

> **get** **length**(): `number`

##### Returns

`number`

#### Implementation of

`Queue.length`

#### Defined in

[foundation/ts/priority-array.ts:15](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L15)

## Methods

### add()

> **add**(`value`): `void`

#### Parameters

##### value

`T`

#### Returns

`void`

#### Implementation of

`Queue.add`

#### Defined in

[foundation/ts/priority-array.ts:19](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L19)

***

### peek()

> **peek**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.peek`

#### Defined in

[foundation/ts/priority-array.ts:33](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L33)

***

### remove()

> **remove**(`item`): `void`

#### Parameters

##### item

`T`

#### Returns

`void`

#### Implementation of

`Queue.remove`

#### Defined in

[foundation/ts/priority-array.ts:37](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L37)

***

### take()

> **take**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.take`

#### Defined in

[foundation/ts/priority-array.ts:49](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L49)

***

### toArray()

> **toArray**(): `T`[]

#### Returns

`T`[]

#### Implementation of

`Queue.toArray`

#### Defined in

[foundation/ts/priority-array.ts:53](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L53)

***

### values()

> **values**(): `Generator`\<`T`, `void`, `undefined`\>

#### Returns

`Generator`\<`T`, `void`, `undefined`\>

#### Implementation of

`Queue.values`

#### Defined in

[foundation/ts/priority-array.ts:57](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-array.ts#L57)
