[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / PriorityLinkedList

# Class: PriorityLinkedList\<T\>

## Type Parameters

• **T**

## Implements

- [`Queue`](../type-aliases/Queue.md)\<`T`\>

## Constructors

### new PriorityLinkedList()

> **new PriorityLinkedList**\<`T`\>(`comparator`): [`PriorityLinkedList`](PriorityLinkedList.md)\<`T`\>

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`PriorityLinkedList`](PriorityLinkedList.md)\<`T`\>

#### Defined in

[foundation/ts/priority-linked-list.ts:8](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L8)

## Accessors

### length

#### Get Signature

> **get** **length**(): `number`

##### Returns

`number`

#### Implementation of

`Queue.length`

#### Defined in

[foundation/ts/priority-linked-list.ts:32](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L32)

## Methods

### add()

> **add**(`item`): `void`

#### Parameters

##### item

`T`

#### Returns

`void`

#### Implementation of

`Queue.add`

#### Defined in

[foundation/ts/priority-linked-list.ts:11](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L11)

***

### peek()

> **peek**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.peek`

#### Defined in

[foundation/ts/priority-linked-list.ts:36](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L36)

***

### remove()

> **remove**(`item`): `void`

#### Parameters

##### item

`T`

#### Returns

`void`

#### Implementation of

`Queue.remove`

#### Defined in

[foundation/ts/priority-linked-list.ts:40](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L40)

***

### take()

> **take**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.take`

#### Defined in

[foundation/ts/priority-linked-list.ts:53](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L53)

***

### toArray()

> **toArray**(): `T`[]

#### Returns

`T`[]

#### Implementation of

`Queue.toArray`

#### Defined in

[foundation/ts/priority-linked-list.ts:57](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L57)

***

### values()

> **values**(): `Generator`\<`T`, `void`, `undefined`\>

#### Returns

`Generator`\<`T`, `void`, `undefined`\>

#### Implementation of

`Queue.values`

#### Defined in

[foundation/ts/priority-linked-list.ts:61](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/priority-linked-list.ts#L61)
