[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / SkipList

# Class: SkipList\<T\>

## Type Parameters

• **T**

## Implements

- [`Queue`](../type-aliases/Queue.md)\<`T`\>

## Constructors

### new SkipList()

> **new SkipList**\<`T`\>(`comparator`, `maxLevel`, `random`): [`SkipList`](SkipList.md)\<`T`\>

#### Parameters

##### comparator

`Comparator`\<`T`\>

##### maxLevel

`number` = `8`

##### random

() => `number`

#### Returns

[`SkipList`](SkipList.md)\<`T`\>

#### Defined in

[foundation/ts/skip-list.ts:17](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L17)

## Properties

### comparator

> `protected` `readonly` **comparator**: `Comparator`\<`T`\>

#### Defined in

[foundation/ts/skip-list.ts:18](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L18)

***

### maxLevel

> `protected` `readonly` **maxLevel**: `number` = `8`

#### Defined in

[foundation/ts/skip-list.ts:19](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L19)

***

### random()

> `protected` `readonly` **random**: () => `number`

#### Returns

`number`

#### Defined in

[foundation/ts/skip-list.ts:20](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L20)

## Accessors

### length

#### Get Signature

> **get** **length**(): `number`

##### Returns

`number`

#### Implementation of

`Queue.length`

#### Defined in

[foundation/ts/skip-list.ts:81](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L81)

## Methods

### add()

> **add**(`value`): `void`

#### Parameters

##### value

`T`

#### Returns

`void`

#### Implementation of

`Queue.add`

#### Defined in

[foundation/ts/skip-list.ts:40](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L40)

***

### buildNode()

> `protected` **buildNode**(`value`, `level`): `SkipNode`\<`T`\>

#### Parameters

##### value

`T`

##### level

`number`

#### Returns

`SkipNode`\<`T`\>

#### Defined in

[foundation/ts/skip-list.ts:118](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L118)

***

### peek()

> **peek**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.peek`

#### Defined in

[foundation/ts/skip-list.ts:85](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L85)

***

### randomLevel()

> `protected` **randomLevel**(): `number`

#### Returns

`number`

#### Defined in

[foundation/ts/skip-list.ts:122](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L122)

***

### remove()

> **remove**(`value`): `void`

#### Parameters

##### value

`T`

#### Returns

`void`

#### Implementation of

`Queue.remove`

#### Defined in

[foundation/ts/skip-list.ts:62](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L62)

***

### take()

> **take**(): `undefined` \| `T`

#### Returns

`undefined` \| `T`

#### Implementation of

`Queue.take`

#### Defined in

[foundation/ts/skip-list.ts:89](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L89)

***

### toArray()

> **toArray**(): `T`[]

#### Returns

`T`[]

#### Implementation of

`Queue.toArray`

#### Defined in

[foundation/ts/skip-list.ts:98](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L98)

***

### values()

> **values**(): `Generator`\<`T`, `void`, `undefined`\>

#### Returns

`Generator`\<`T`, `void`, `undefined`\>

#### Implementation of

`Queue.values`

#### Defined in

[foundation/ts/skip-list.ts:102](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L102)

***

### valuesAndIndexes()

> **valuesAndIndexes**(): `Generator`\<[`T`, `number`], `void`, `undefined`\>

#### Returns

`Generator`\<[`T`, `number`], `void`, `undefined`\>

#### Defined in

[foundation/ts/skip-list.ts:108](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/skip-list.ts#L108)
