[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / BinaryIndexOfConfig

# Type Alias: BinaryIndexOfConfig

> **BinaryIndexOfConfig**: `object`

## Type declaration

### firstNonUnique?

> `optional` **firstNonUnique**: `boolean`

The values may not be unique, and the result should be the
index of the first occurrence.
When a value is found, step back and compare until the first
occurrence of that value is found.  Will always cause extra
comparisons.

#### Default

```ts
{false}
```

### initialLeft?

> `optional` **initialLeft**: `number`

Left-most index to check.  Inclusive.

#### Default

```ts
{0}
```

### initialRight?

> `optional` **initialRight**: `number`

Right-most index, considered out-of-bounds.  Exclusive.

#### Default

```ts
The length of the array.
```

### rangeCheck?

> `optional` **rangeCheck**: `boolean`

Perform an initial check against the first and last elements.
Can speed up searches where you expect the value to be less
than or greater than all the elements, such as when you mostly
insert at the front or append to the back.
But it can just add extra comparisons for small arrays, or
arrays where most values will be in the middle.

#### Default

```ts
{false}
```

## Defined in

[foundation/ts/binary-index-of.ts:15](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/binary-index-of.ts#L15)
