[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / PropertiesFromDescriptors

# Type Alias: PropertiesFromDescriptors\<R\>

> **PropertiesFromDescriptors**\<`R`\>: `{ readonly [K in ReadOnlyDescriptorsKeys<R>]: R[K] extends TypedPropertyDescriptor<infer V> ? V : never }` & `{ [K in ReadWriteDescriptorsKeys<R>]: R[K] extends TypedPropertyDescriptor<infer V> ? V : never }` & `{ [K in RenamedWriteOnlyDescriptorsKeys<R>]?: undefined }`

Produce an object with the properties described by the descriptors.
See [RenameIfWriteOnlyDescriptor](RenameIfWriteOnlyDescriptor.md) for details on the mangling
of write-only properties.

## Type Parameters

• **R** *extends* `Record`\<`string`, [`TypedPropertyDescriptor`](TypedPropertyDescriptor.md)\<`unknown`\>\>

## Defined in

[foundation/ts/add-property.ts:140](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/add-property.ts#L140)
