[**@rickosborne/foundation v2024.12.28**](../README.md)

***

[@rickosborne/foundation](../README.md) / PropertyFromDescriptor

# Type Alias: PropertyFromDescriptor\<K, D\>

> **PropertyFromDescriptor**\<`K`, `D`\>: `D` *extends* [`TypedPropertyDescriptor`](TypedPropertyDescriptor.md)\<infer V\> ? `{ readonly [key in IfReadOnlyDescriptor<K, D>]: V }` & `{ [key in IfReadWriteDescriptor<K, D>]: V }` & `{ [key in RenameIfWriteOnlyDescriptor<K, D>]?: undefined }` : `never`

Produce a single-property object type for the given property
descriptor.  Note: will produce an additional mangled pseudo-property
for write-only properties.
See [RenameIfWriteOnlyDescriptor](RenameIfWriteOnlyDescriptor.md) for details on the mangling.

## Type Parameters

• **K** *extends* `string`

• **D** *extends* [`TypedPropertyDescriptor`](TypedPropertyDescriptor.md)\<`unknown`\>

## Defined in

[foundation/ts/add-property.ts:127](https://github.com/rickosborne/es-js-ts/blob/b9df3c6eb00a5aca153cd4895e7af44eeb074ddb/foundation/ts/add-property.ts#L127)
